'' Serial Keyboard Driver for Sphinx
'' *********************************
'' (c) Andy Schenk, Jul 2009
'  based on JDCogSerial
''
'' This object expects that sxtv_pc is also included and started

  SXKBRENDEZVOUS = $7ff8

VAR
  long pRendezvous, kstat

PUB start(pingroup) : okay
'' Init keyboard driver (pingroup = dummy parameter)

  pRendezvous := SXKBRENDEZVOUS
  okay := True

PUB peekkey
'' Returns a 0 if the buffer is empty
'' returns next key if buffer not empty
'' but doesn't remove the key from buffer

  return long[pRendezvous]
  
PUB key : keycode

'' Get key (never waits)
'' returns key (0 if buffer empty)

  keycode := long[pRendezvous]
  if keycode
    long[pRendezvous]~
    case keycode
      5:  repeat 3                'filter PropTerminal Mouse Events out
            repeat until long[pRendezvous]
            long[pRendezvous]~
          keycode~
      1:  kstat |= $100           'Shift/Control state from PropTerminal
          keycode~
      2:  kstat |= $200
          keycode~
      3:  kstat &= !$100
          keycode~
      4:  kstat &= !$200
          keycode~
      32..127: kstat &= !$100
    keycode |= kstat              'add Shift/Control

PUB getkey : keycode

'' Get next key (may wait for keypress)
'' returns key

  repeat until (keycode := key)

PUB rx : rxdata

'' Wait for a byte from serial in
'' returns byte

  repeat until rxdata := long[pRendezvous]
  long[pRendezvous]~
  rxdata &= $FF       '$100 -> $00
